package cn.ibizlab.r7.runtime.org.core.r7rt_base.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import java.io.Serializable;

/**
 * 实体[登录账号]
 */
public class LoginAccount implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 确认密码
     */
    private String confirmpwd;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean confirmpwdDirtyFlag;

    /**
     * 更新时间
     */
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean updateDateDirtyFlag;

    /**
     * 登录账号标识
     */
    private String loginAccountId;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean loginAccountIdDirtyFlag;

    /**
     * 密码
     */
    private String pwd;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean pwdDirtyFlag;

    /**
     * 建立时间
     */
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean createDateDirtyFlag;

    /**
     * 密码修改标记
     */
    private String pwdchanged;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean pwdchangedDirtyFlag;

    /**
     * 最近一次密码变更时间
     */
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp lastPwdChgTime;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean lastPwdChgTimeDirtyFlag;

    /**
     * 登录账号名称
     */
    private String loginAccountName;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean loginAccountNameDirtyFlag;

    /**
     * 建立人
     */
    private String createMan;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean createManDirtyFlag;

    /**
     * 是否是超级用户
     */
    private String isSuperUser;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean isSuperUserDirtyFlag;

    /**
     * 是否启用
     */
    private Integer enable;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean enableDirtyFlag;

    /**
     * 最近一次密码变更人
     */
    private String lastpwdchgman;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean lastpwdchgmanDirtyFlag;

    /**
     * 更新人
     */
    private String updateMan;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean updateManDirtyFlag;

    /**
     * 旧密码
     */
    private String oldpwd;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean oldpwdDirtyFlag;

    /**
     * 用户名称
     */
    private String userName;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean userNameDirtyFlag;

    /**
     * 用户标识
     */
    private String userId;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean userIdDirtyFlag;


    /**
     * 获取 [确认密码]
     */
    @JsonProperty("confirmpwd")
    @JSONField(name="confirmpwd")
    public String getConfirmpwd(){
        return this.confirmpwd ;
    }

    /**
     * 设置 [确认密码]
     */
    @JsonProperty("confirmpwd")
    @JSONField(name="confirmpwd")
    public void setConfirmpwd(String confirmpwd){
        this.confirmpwd = confirmpwd ;
        this.confirmpwdDirtyFlag = true ;
    }

    /**
     * 获取 [确认密码]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getConfirmpwdDirtyFlag(){
        return this.confirmpwdDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    @JsonProperty("updatedate")
    @JSONField(name="updatedate")
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    @JsonProperty("updatedate")
    @JSONField(name="updatedate")
    public void setUpdateDate(Timestamp updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [登录账号标识]
     */
    @JsonProperty("loginaccountid")
    @JSONField(name="loginaccountid")
    public String getLoginAccountId(){
        return this.loginAccountId ;
    }

    /**
     * 设置 [登录账号标识]
     */
    @JsonProperty("loginaccountid")
    @JSONField(name="loginaccountid")
    public void setLoginAccountId(String loginAccountId){
        this.loginAccountId = loginAccountId ;
        this.loginAccountIdDirtyFlag = true ;
    }

    /**
     * 获取 [登录账号标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getLoginAccountIdDirtyFlag(){
        return this.loginAccountIdDirtyFlag ;
    }
    /**
     * 获取 [密码]
     */
    @JsonProperty("pwd")
    @JSONField(name="pwd")
    public String getPwd(){
        return this.pwd ;
    }

    /**
     * 设置 [密码]
     */
    @JsonProperty("pwd")
    @JSONField(name="pwd")
    public void setPwd(String pwd){
        this.pwd = pwd ;
        this.pwdDirtyFlag = true ;
    }

    /**
     * 获取 [密码]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getPwdDirtyFlag(){
        return this.pwdDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    @JsonProperty("createdate")
    @JSONField(name="createdate")
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    @JsonProperty("createdate")
    @JSONField(name="createdate")
    public void setCreateDate(Timestamp createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [密码修改标记]
     */
    @JsonProperty("pwdchanged")
    @JSONField(name="pwdchanged")
    public String getPwdchanged(){
        return this.pwdchanged ;
    }

    /**
     * 设置 [密码修改标记]
     */
    @JsonProperty("pwdchanged")
    @JSONField(name="pwdchanged")
    public void setPwdchanged(String pwdchanged){
        this.pwdchanged = pwdchanged ;
        this.pwdchangedDirtyFlag = true ;
    }

    /**
     * 获取 [密码修改标记]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getPwdchangedDirtyFlag(){
        return this.pwdchangedDirtyFlag ;
    }
    /**
     * 获取 [最近一次密码变更时间]
     */
    @JsonProperty("lastpwdchgtime")
    @JSONField(name="lastpwdchgtime")
    public Timestamp getLastPwdChgTime(){
        return this.lastPwdChgTime ;
    }

    /**
     * 设置 [最近一次密码变更时间]
     */
    @JsonProperty("lastpwdchgtime")
    @JSONField(name="lastpwdchgtime")
    public void setLastPwdChgTime(Timestamp lastPwdChgTime){
        this.lastPwdChgTime = lastPwdChgTime ;
        this.lastPwdChgTimeDirtyFlag = true ;
    }

    /**
     * 获取 [最近一次密码变更时间]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getLastPwdChgTimeDirtyFlag(){
        return this.lastPwdChgTimeDirtyFlag ;
    }
    /**
     * 获取 [登录账号名称]
     */
    @JsonProperty("loginaccountname")
    @JSONField(name="loginaccountname")
    public String getLoginAccountName(){
        return this.loginAccountName ;
    }

    /**
     * 设置 [登录账号名称]
     */
    @JsonProperty("loginaccountname")
    @JSONField(name="loginaccountname")
    public void setLoginAccountName(String loginAccountName){
        this.loginAccountName = loginAccountName ;
        this.loginAccountNameDirtyFlag = true ;
    }

    /**
     * 获取 [登录账号名称]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getLoginAccountNameDirtyFlag(){
        return this.loginAccountNameDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    @JsonProperty("createman")
    @JSONField(name="createman")
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    @JsonProperty("createman")
    @JSONField(name="createman")
    public void setCreateMan(String createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [是否是超级用户]
     */
    @JsonProperty("issuperuser")
    @JSONField(name="issuperuser")
    public String getIsSuperUser(){
        return this.isSuperUser ;
    }

    /**
     * 设置 [是否是超级用户]
     */
    @JsonProperty("issuperuser")
    @JSONField(name="issuperuser")
    public void setIsSuperUser(String isSuperUser){
        this.isSuperUser = isSuperUser ;
        this.isSuperUserDirtyFlag = true ;
    }

    /**
     * 获取 [是否是超级用户]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getIsSuperUserDirtyFlag(){
        return this.isSuperUserDirtyFlag ;
    }
    /**
     * 获取 [是否启用]
     */
    @JsonProperty("enable")
    @JSONField(name="enable")
    public Integer getEnable(){
        return this.enable ;
    }

    /**
     * 设置 [是否启用]
     */
    @JsonProperty("enable")
    @JSONField(name="enable")
    public void setEnable(Integer enable){
        this.enable = enable ;
        this.enableDirtyFlag = true ;
    }

    /**
     * 获取 [是否启用]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getEnableDirtyFlag(){
        return this.enableDirtyFlag ;
    }
    /**
     * 获取 [最近一次密码变更人]
     */
    @JsonProperty("lastpwdchgman")
    @JSONField(name="lastpwdchgman")
    public String getLastpwdchgman(){
        return this.lastpwdchgman ;
    }

    /**
     * 设置 [最近一次密码变更人]
     */
    @JsonProperty("lastpwdchgman")
    @JSONField(name="lastpwdchgman")
    public void setLastpwdchgman(String lastpwdchgman){
        this.lastpwdchgman = lastpwdchgman ;
        this.lastpwdchgmanDirtyFlag = true ;
    }

    /**
     * 获取 [最近一次密码变更人]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getLastpwdchgmanDirtyFlag(){
        return this.lastpwdchgmanDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    @JsonProperty("updateman")
    @JSONField(name="updateman")
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    @JsonProperty("updateman")
    @JSONField(name="updateman")
    public void setUpdateMan(String updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [旧密码]
     */
    @JsonProperty("oldpwd")
    @JSONField(name="oldpwd")
    public String getOldpwd(){
        return this.oldpwd ;
    }

    /**
     * 设置 [旧密码]
     */
    @JsonProperty("oldpwd")
    @JSONField(name="oldpwd")
    public void setOldpwd(String oldpwd){
        this.oldpwd = oldpwd ;
        this.oldpwdDirtyFlag = true ;
    }

    /**
     * 获取 [旧密码]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getOldpwdDirtyFlag(){
        return this.oldpwdDirtyFlag ;
    }
    /**
     * 获取 [用户名称]
     */
    @JsonProperty("username")
    @JSONField(name="username")
    public String getUserName(){
        return this.userName ;
    }

    /**
     * 设置 [用户名称]
     */
    @JsonProperty("username")
    @JSONField(name="username")
    public void setUserName(String userName){
        this.userName = userName ;
        this.userNameDirtyFlag = true ;
    }

    /**
     * 获取 [用户名称]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getUserNameDirtyFlag(){
        return this.userNameDirtyFlag ;
    }
    /**
     * 获取 [用户标识]
     */
    @JsonProperty("userid")
    @JSONField(name="userid")
    public String getUserId(){
        return this.userId ;
    }

    /**
     * 设置 [用户标识]
     */
    @JsonProperty("userid")
    @JSONField(name="userid")
    public void setUserId(String userId){
        this.userId = userId ;
        this.userIdDirtyFlag = true ;
    }

    /**
     * 获取 [用户标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getUserIdDirtyFlag(){
        return this.userIdDirtyFlag ;
    }

}

