package cn.ibizlab.r7.runtime.org.core.r7rt_base.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import java.io.Serializable;

/**
 * 实体[用户]
 */
public class User implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 证件类型
     */
    private String certType;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean certTypeDirtyFlag;

    /**
     * 建立人
     */
    private String createMan;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean createManDirtyFlag;

    /**
     * 是否启用
     */
    private Integer enable;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean enableDirtyFlag;

    /**
     * 用户名称
     */
    private String userName;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean userNameDirtyFlag;

    /**
     * 登录名
     */
    private String loginName;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean loginNameDirtyFlag;

    /**
     * 更新时间
     */
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean updateDateDirtyFlag;

    /**
     * 用户编号
     */
    private String userCode;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean userCodeDirtyFlag;

    /**
     * 用户标识
     */
    private String userId;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean userIdDirtyFlag;

    /**
     * 用户对象类型
     */
    private String userObjectType;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean userObjectTypeDirtyFlag;

    /**
     * 性别
     */
    private String sex;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean sexDirtyFlag;

    /**
     * 移动电话
     */
    private String mobilePhone;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean mobilePhoneDirtyFlag;

    /**
     * 证件号码
     */
    private String certNo;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean certNoDirtyFlag;

    /**
     * 更新人
     */
    private String updateMan;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean updateManDirtyFlag;

    /**
     * 备注
     */
    private String memo;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean memoDirtyFlag;

    /**
     * 建立时间
     */
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean createDateDirtyFlag;


    /**
     * 获取 [证件类型]
     */
    @JsonProperty("certtype")
    @JSONField(name="certtype")
    public String getCertType(){
        return this.certType ;
    }

    /**
     * 设置 [证件类型]
     */
    @JsonProperty("certtype")
    @JSONField(name="certtype")
    public void setCertType(String certType){
        this.certType = certType ;
        this.certTypeDirtyFlag = true ;
    }

    /**
     * 获取 [证件类型]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getCertTypeDirtyFlag(){
        return this.certTypeDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    @JsonProperty("createman")
    @JSONField(name="createman")
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    @JsonProperty("createman")
    @JSONField(name="createman")
    public void setCreateMan(String createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [是否启用]
     */
    @JsonProperty("enable")
    @JSONField(name="enable")
    public Integer getEnable(){
        return this.enable ;
    }

    /**
     * 设置 [是否启用]
     */
    @JsonProperty("enable")
    @JSONField(name="enable")
    public void setEnable(Integer enable){
        this.enable = enable ;
        this.enableDirtyFlag = true ;
    }

    /**
     * 获取 [是否启用]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getEnableDirtyFlag(){
        return this.enableDirtyFlag ;
    }
    /**
     * 获取 [用户名称]
     */
    @JsonProperty("username")
    @JSONField(name="username")
    public String getUserName(){
        return this.userName ;
    }

    /**
     * 设置 [用户名称]
     */
    @JsonProperty("username")
    @JSONField(name="username")
    public void setUserName(String userName){
        this.userName = userName ;
        this.userNameDirtyFlag = true ;
    }

    /**
     * 获取 [用户名称]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getUserNameDirtyFlag(){
        return this.userNameDirtyFlag ;
    }
    /**
     * 获取 [登录名]
     */
    @JsonProperty("loginname")
    @JSONField(name="loginname")
    public String getLoginName(){
        return this.loginName ;
    }

    /**
     * 设置 [登录名]
     */
    @JsonProperty("loginname")
    @JSONField(name="loginname")
    public void setLoginName(String loginName){
        this.loginName = loginName ;
        this.loginNameDirtyFlag = true ;
    }

    /**
     * 获取 [登录名]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getLoginNameDirtyFlag(){
        return this.loginNameDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    @JsonProperty("updatedate")
    @JSONField(name="updatedate")
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    @JsonProperty("updatedate")
    @JSONField(name="updatedate")
    public void setUpdateDate(Timestamp updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [用户编号]
     */
    @JsonProperty("usercode")
    @JSONField(name="usercode")
    public String getUserCode(){
        return this.userCode ;
    }

    /**
     * 设置 [用户编号]
     */
    @JsonProperty("usercode")
    @JSONField(name="usercode")
    public void setUserCode(String userCode){
        this.userCode = userCode ;
        this.userCodeDirtyFlag = true ;
    }

    /**
     * 获取 [用户编号]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getUserCodeDirtyFlag(){
        return this.userCodeDirtyFlag ;
    }
    /**
     * 获取 [用户标识]
     */
    @JsonProperty("userid")
    @JSONField(name="userid")
    public String getUserId(){
        return this.userId ;
    }

    /**
     * 设置 [用户标识]
     */
    @JsonProperty("userid")
    @JSONField(name="userid")
    public void setUserId(String userId){
        this.userId = userId ;
        this.userIdDirtyFlag = true ;
    }

    /**
     * 获取 [用户标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getUserIdDirtyFlag(){
        return this.userIdDirtyFlag ;
    }
    /**
     * 获取 [用户对象类型]
     */
    @JsonProperty("userobjecttype")
    @JSONField(name="userobjecttype")
    public String getUserObjectType(){
        return this.userObjectType ;
    }

    /**
     * 设置 [用户对象类型]
     */
    @JsonProperty("userobjecttype")
    @JSONField(name="userobjecttype")
    public void setUserObjectType(String userObjectType){
        this.userObjectType = userObjectType ;
        this.userObjectTypeDirtyFlag = true ;
    }

    /**
     * 获取 [用户对象类型]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getUserObjectTypeDirtyFlag(){
        return this.userObjectTypeDirtyFlag ;
    }
    /**
     * 获取 [性别]
     */
    @JsonProperty("sex")
    @JSONField(name="sex")
    public String getSex(){
        return this.sex ;
    }

    /**
     * 设置 [性别]
     */
    @JsonProperty("sex")
    @JSONField(name="sex")
    public void setSex(String sex){
        this.sex = sex ;
        this.sexDirtyFlag = true ;
    }

    /**
     * 获取 [性别]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getSexDirtyFlag(){
        return this.sexDirtyFlag ;
    }
    /**
     * 获取 [移动电话]
     */
    @JsonProperty("mobilephone")
    @JSONField(name="mobilephone")
    public String getMobilePhone(){
        return this.mobilePhone ;
    }

    /**
     * 设置 [移动电话]
     */
    @JsonProperty("mobilephone")
    @JSONField(name="mobilephone")
    public void setMobilePhone(String mobilePhone){
        this.mobilePhone = mobilePhone ;
        this.mobilePhoneDirtyFlag = true ;
    }

    /**
     * 获取 [移动电话]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getMobilePhoneDirtyFlag(){
        return this.mobilePhoneDirtyFlag ;
    }
    /**
     * 获取 [证件号码]
     */
    @JsonProperty("certno")
    @JSONField(name="certno")
    public String getCertNo(){
        return this.certNo ;
    }

    /**
     * 设置 [证件号码]
     */
    @JsonProperty("certno")
    @JSONField(name="certno")
    public void setCertNo(String certNo){
        this.certNo = certNo ;
        this.certNoDirtyFlag = true ;
    }

    /**
     * 获取 [证件号码]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getCertNoDirtyFlag(){
        return this.certNoDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    @JsonProperty("updateman")
    @JSONField(name="updateman")
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    @JsonProperty("updateman")
    @JSONField(name="updateman")
    public void setUpdateMan(String updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [备注]
     */
    @JsonProperty("memo")
    @JSONField(name="memo")
    public String getMemo(){
        return this.memo ;
    }

    /**
     * 设置 [备注]
     */
    @JsonProperty("memo")
    @JSONField(name="memo")
    public void setMemo(String memo){
        this.memo = memo ;
        this.memoDirtyFlag = true ;
    }

    /**
     * 获取 [备注]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getMemoDirtyFlag(){
        return this.memoDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    @JsonProperty("createdate")
    @JSONField(name="createdate")
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    @JsonProperty("createdate")
    @JSONField(name="createdate")
    public void setCreateDate(Timestamp createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }

}

