package cn.ibizlab.r7.runtime.org.core.r7rt_base.valuerule.anno.usergroup;

import cn.ibizlab.r7.runtime.org.core.r7rt_base.valuerule.validator.usergroup.UserGroupDataSourceTypeDefaultValidator;

import javax.validation.Constraint;
import javax.validation.Payload;
import java.lang.annotation.*;

/**
 * 值规则注解
 * 实体：UserGroup
 * 属性：DataSourceType
 * 值规则：Default
 */
@Target({ElementType.METHOD, ElementType.FIELD, ElementType.PARAMETER})
@Retention(RetentionPolicy.RUNTIME)
@Documented
@Constraint(validatedBy = {UserGroupDataSourceTypeDefaultValidator.class})
public @interface UserGroupDataSourceTypeDefault {
    //是否默认检查
    boolean flag() default true;

    //值规则名称
    String info() default "默认规则";

    //值规则信息，如果为空，使用值规则名称。
    String message() default "内容长度必须小于等于[60]";

    Class<?>[] groups() default {};

    Class<? extends Payload>[] payload() default {};
}
