package cn.ibizlab.r7.runtime.org.core.r7rt_org.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.org.core.r7rt_org.domain.OrgDept;
import cn.ibizlab.r7.runtime.org.core.r7rt_org.filter.OrgDeptSearchContext;
import cn.ibizlab.r7.runtime.org.core.r7rt_org.service.IOrgDeptService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.org.util.SearchResult;

/**
 * 实体[部门] 服务对象接口实现
 */
@Service
public class OrgDeptServiceImpl implements IOrgDeptService {

    @Autowired
    cn.ibizlab.r7.runtime.org.core.repository.OrgDeptRepository orgDeptRepository;

    @Override
    @Transactional
    public boolean update(OrgDept orgdept) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.org.core.repository.po.OrgDept t_ORGDEPT = orgDeptRepository.convert2PO(orgdept,null);
        bOk = orgDeptRepository.update(t_ORGDEPT);
        orgDeptRepository.convert2Domain(t_ORGDEPT,orgdept) ;
        return bOk ;
    }

    @Override
    @Transactional
    public boolean remove(String orgdeptid) {
        boolean bOk = false ;

        OrgDept _orgDept = this.get(orgdeptid);
        bOk = orgDeptRepository.remove(orgdeptid);

        return bOk ;
    }

    @Override
    @Transactional
    public OrgDept get(String orgdeptid) {
        cn.ibizlab.r7.runtime.org.core.repository.po.OrgDept _t_ORGDEPT = orgDeptRepository.get(orgdeptid);
        if(_t_ORGDEPT == null)
            return null ;

        OrgDept _orgDept = orgDeptRepository.convert2Domain(_t_ORGDEPT,null) ;

        return _orgDept;
    }

    @Override
    @Transactional
    public OrgDept get(OrgDept orgdept) {
        cn.ibizlab.r7.runtime.org.core.repository.po.OrgDept t_ORGDEPT = orgDeptRepository.get(orgdept.getOrgDeptId());
        orgDeptRepository.convert2Domain(t_ORGDEPT,orgdept);
        return orgdept;
    }

    @Override
    public boolean checkKey(OrgDept orgdept) {
        return true;
    }

    @Override
    @Transactional
    public boolean create(OrgDept orgdept) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.org.core.repository.po.OrgDept t_ORGDEPT = orgDeptRepository.convert2PO(orgdept,null);
        bOk = orgDeptRepository.create(t_ORGDEPT);
        orgDeptRepository.convert2Domain(t_ORGDEPT,orgdept);


        return bOk ;
    }

    @Override
    public OrgDept getDraft(OrgDept orgdept) {
        return orgdept;
    }

    @Override
    @Transactional
    public OrgDept getOrgDeptChild(OrgDept orgdept) {
         return orgdept;
    }

    @Override
    @Transactional
    public boolean save(OrgDept orgdept) {
        if(orgdept.getOrgDeptId()==null){
    		return create(orgdept);
    	}else{
            if(this.get(orgdept.getOrgDeptId())!=null){
    			return update(orgdept);
    		}
    		return create(orgdept);
    	}
    }

    @Override
    @Transactional
    public OrgDept syncToUserGroup(OrgDept orgdept) {
         return orgdept;
    }

    @Override
    @Transactional
    public OrgDept getOrgDeptPrent(OrgDept orgdept) {
         return orgdept;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<OrgDept> searchDefault(OrgDeptSearchContext context) {
        List<OrgDept> list = new ArrayList<OrgDept>();
        Page<cn.ibizlab.r7.runtime.org.core.repository.po.OrgDept> t_ORGDEPTs = orgDeptRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.org.core.repository.po.OrgDept t_ORGDEPT : t_ORGDEPTs){
            list.add(orgDeptRepository.convert2Domain(t_ORGDEPT,null));
        }
        return new PageImpl<OrgDept>(list, context.getPageable(), t_ORGDEPTs.getTotalElements());
    }

    /**
     * 查询集合 当前组织下的部门
     */
    @Override
    public Page<OrgDept> searchCUR_ORG(OrgDeptSearchContext context) {
        List<OrgDept> list = new ArrayList<OrgDept>();
        Page<cn.ibizlab.r7.runtime.org.core.repository.po.OrgDept> t_ORGDEPTs = orgDeptRepository.searchCUR_ORG(context) ;
        for(cn.ibizlab.r7.runtime.org.core.repository.po.OrgDept t_ORGDEPT : t_ORGDEPTs){
            list.add(orgDeptRepository.convert2Domain(t_ORGDEPT,null));
        }
        return new PageImpl<OrgDept>(list, context.getPageable(), t_ORGDEPTs.getTotalElements());
    }


    /**
     * 根据部门查询
     */
    @Override
    public Page<OrgDept> selectByPOrgDept(String orgdeptid){
        OrgDeptSearchContext context = new OrgDeptSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptid)){
            cn.ibizlab.r7.runtime.org.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.org.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.org.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptid);
            context.getCondition().add(fieldFilter);
        }
        List<OrgDept> list = new ArrayList<OrgDept>();
        Page<cn.ibizlab.r7.runtime.org.core.repository.po.OrgDept> t_ORGDEPTs = orgDeptRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.org.core.repository.po.OrgDept t_ORGDEPT : t_ORGDEPTs){
            list.add(orgDeptRepository.convert2Domain(t_ORGDEPT,null));
        }
        return new PageImpl<OrgDept>(list, context.getPageable(), t_ORGDEPTs.getTotalElements());
    }

    /**
     * 根据部门查询
     */
    @Override
    public List<OrgDept> selectByPOrgDept2(String orgdeptid){
        OrgDeptSearchContext context = new OrgDeptSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptid)){
            cn.ibizlab.r7.runtime.org.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.org.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.org.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptid);
            context.getCondition().add(fieldFilter);
        }
        List<OrgDept> list = new ArrayList<OrgDept>();
        Page<cn.ibizlab.r7.runtime.org.core.repository.po.OrgDept> t_ORGDEPTs = orgDeptRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.org.core.repository.po.OrgDept t_ORGDEPT : t_ORGDEPTs){
            list.add(orgDeptRepository.convert2Domain(t_ORGDEPT,null));
        }
        return list;
    }
    /**
     * 根据组织查询
     */
    @Override
    public Page<OrgDept> selectByOrg(String orgid){
        OrgDeptSearchContext context = new OrgDeptSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgid)){
            cn.ibizlab.r7.runtime.org.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.org.util.SearchFieldFilter();
            fieldFilter.setParam("orgid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.org.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgid);
            context.getCondition().add(fieldFilter);
        }
        List<OrgDept> list = new ArrayList<OrgDept>();
        Page<cn.ibizlab.r7.runtime.org.core.repository.po.OrgDept> t_ORGDEPTs = orgDeptRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.org.core.repository.po.OrgDept t_ORGDEPT : t_ORGDEPTs){
            list.add(orgDeptRepository.convert2Domain(t_ORGDEPT,null));
        }
        return new PageImpl<OrgDept>(list, context.getPageable(), t_ORGDEPTs.getTotalElements());
    }

    /**
     * 根据组织查询
     */
    @Override
    public List<OrgDept> selectByOrg2(String orgid){
        OrgDeptSearchContext context = new OrgDeptSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgid)){
            cn.ibizlab.r7.runtime.org.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.org.util.SearchFieldFilter();
            fieldFilter.setParam("orgid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.org.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgid);
            context.getCondition().add(fieldFilter);
        }
        List<OrgDept> list = new ArrayList<OrgDept>();
        Page<cn.ibizlab.r7.runtime.org.core.repository.po.OrgDept> t_ORGDEPTs = orgDeptRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.org.core.repository.po.OrgDept t_ORGDEPT : t_ORGDEPTs){
            list.add(orgDeptRepository.convert2Domain(t_ORGDEPT,null));
        }
        return list;
    }




}
