package cn.ibizlab.r7.runtime.org.core.r7rt_org.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.org.core.r7rt_org.domain.OrgDeptUser;
import cn.ibizlab.r7.runtime.org.core.r7rt_org.filter.OrgDeptUserSearchContext;
import cn.ibizlab.r7.runtime.org.core.r7rt_org.service.IOrgDeptUserService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.org.util.SearchResult;

/**
 * 实体[部门用户] 服务对象接口实现
 */
@Service
public class OrgDeptUserServiceImpl implements IOrgDeptUserService {

    @Autowired
    cn.ibizlab.r7.runtime.org.core.repository.OrgDeptUserRepository orgDeptUserRepository;

    @Override
    @Transactional
    public OrgDeptUser get(String orgdeptuserid) {
        cn.ibizlab.r7.runtime.org.core.repository.po.OrgDeptUser _t_ORGDEPTUSER = orgDeptUserRepository.get(orgdeptuserid);
        if(_t_ORGDEPTUSER == null)
            return null ;

        OrgDeptUser _orgDeptUser = orgDeptUserRepository.convert2Domain(_t_ORGDEPTUSER,null) ;

        return _orgDeptUser;
    }

    @Override
    @Transactional
    public OrgDeptUser get(OrgDeptUser orgdeptuser) {
        cn.ibizlab.r7.runtime.org.core.repository.po.OrgDeptUser t_ORGDEPTUSER = orgDeptUserRepository.get(orgdeptuser.getOrgDeptUserId());
        orgDeptUserRepository.convert2Domain(t_ORGDEPTUSER,orgdeptuser);
        return orgdeptuser;
    }

    @Override
    public OrgDeptUser getDraft(OrgDeptUser orgdeptuser) {
        return orgdeptuser;
    }

    @Override
    @Transactional
    public boolean update(OrgDeptUser orgdeptuser) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.org.core.repository.po.OrgDeptUser t_ORGDEPTUSER = orgDeptUserRepository.convert2PO(orgdeptuser,null);
        bOk = orgDeptUserRepository.update(t_ORGDEPTUSER);
        orgDeptUserRepository.convert2Domain(t_ORGDEPTUSER,orgdeptuser) ;
        return bOk ;
    }

    @Override
    @Transactional
    public boolean create(OrgDeptUser orgdeptuser) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.org.core.repository.po.OrgDeptUser t_ORGDEPTUSER = orgDeptUserRepository.convert2PO(orgdeptuser,null);
        bOk = orgDeptUserRepository.create(t_ORGDEPTUSER);
        orgDeptUserRepository.convert2Domain(t_ORGDEPTUSER,orgdeptuser);


        return bOk ;
    }

    @Override
    @Transactional
    public boolean save(OrgDeptUser orgdeptuser) {
        if(orgdeptuser.getOrgDeptUserId()==null){
    		return create(orgdeptuser);
    	}else{
            if(this.get(orgdeptuser.getOrgDeptUserId())!=null){
    			return update(orgdeptuser);
    		}
    		return create(orgdeptuser);
    	}
    }

    @Override
    @Transactional
    public boolean remove(String orgdeptuserid) {
        boolean bOk = false ;

        OrgDeptUser _orgDeptUser = this.get(orgdeptuserid);
        bOk = orgDeptUserRepository.remove(orgdeptuserid);

        return bOk ;
    }

    @Override
    public boolean checkKey(OrgDeptUser orgdeptuser) {
        return true;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<OrgDeptUser> searchDefault(OrgDeptUserSearchContext context) {
        List<OrgDeptUser> list = new ArrayList<OrgDeptUser>();
        Page<cn.ibizlab.r7.runtime.org.core.repository.po.OrgDeptUser> t_ORGDEPTUSERs = orgDeptUserRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.org.core.repository.po.OrgDeptUser t_ORGDEPTUSER : t_ORGDEPTUSERs){
            list.add(orgDeptUserRepository.convert2Domain(t_ORGDEPTUSER,null));
        }
        return new PageImpl<OrgDeptUser>(list, context.getPageable(), t_ORGDEPTUSERs.getTotalElements());
    }

    /**
     * 查询集合 getorgdeptuser
     */
    @Override
    public Page<OrgDeptUser> searchGetorgdeptuser(OrgDeptUserSearchContext context) {
        List<OrgDeptUser> list = new ArrayList<OrgDeptUser>();
        Page<cn.ibizlab.r7.runtime.org.core.repository.po.OrgDeptUser> t_ORGDEPTUSERs = orgDeptUserRepository.searchGetorgdeptuser(context) ;
        for(cn.ibizlab.r7.runtime.org.core.repository.po.OrgDeptUser t_ORGDEPTUSER : t_ORGDEPTUSERs){
            list.add(orgDeptUserRepository.convert2Domain(t_ORGDEPTUSER,null));
        }
        return new PageImpl<OrgDeptUser>(list, context.getPageable(), t_ORGDEPTUSERs.getTotalElements());
    }


    /**
     * 根据部门查询
     */
    @Override
    public Page<OrgDeptUser> selectByOrgDept(String orgdeptid){
        OrgDeptUserSearchContext context = new OrgDeptUserSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptid)){
            cn.ibizlab.r7.runtime.org.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.org.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.org.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptid);
            context.getCondition().add(fieldFilter);
        }
        List<OrgDeptUser> list = new ArrayList<OrgDeptUser>();
        Page<cn.ibizlab.r7.runtime.org.core.repository.po.OrgDeptUser> t_ORGDEPTUSERs = orgDeptUserRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.org.core.repository.po.OrgDeptUser t_ORGDEPTUSER : t_ORGDEPTUSERs){
            list.add(orgDeptUserRepository.convert2Domain(t_ORGDEPTUSER,null));
        }
        return new PageImpl<OrgDeptUser>(list, context.getPageable(), t_ORGDEPTUSERs.getTotalElements());
    }

    /**
     * 根据部门查询
     */
    @Override
    public List<OrgDeptUser> selectByOrgDept2(String orgdeptid){
        OrgDeptUserSearchContext context = new OrgDeptUserSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptid)){
            cn.ibizlab.r7.runtime.org.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.org.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.org.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptid);
            context.getCondition().add(fieldFilter);
        }
        List<OrgDeptUser> list = new ArrayList<OrgDeptUser>();
        Page<cn.ibizlab.r7.runtime.org.core.repository.po.OrgDeptUser> t_ORGDEPTUSERs = orgDeptUserRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.org.core.repository.po.OrgDeptUser t_ORGDEPTUSER : t_ORGDEPTUSERs){
            list.add(orgDeptUserRepository.convert2Domain(t_ORGDEPTUSER,null));
        }
        return list;
    }
    /**
     * 根据组织用户查询
     */
    @Override
    public Page<OrgDeptUser> selectByOrgUser(String orguserid){
        OrgDeptUserSearchContext context = new OrgDeptUserSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orguserid)){
            cn.ibizlab.r7.runtime.org.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.org.util.SearchFieldFilter();
            fieldFilter.setParam("orguserid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.org.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orguserid);
            context.getCondition().add(fieldFilter);
        }
        List<OrgDeptUser> list = new ArrayList<OrgDeptUser>();
        Page<cn.ibizlab.r7.runtime.org.core.repository.po.OrgDeptUser> t_ORGDEPTUSERs = orgDeptUserRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.org.core.repository.po.OrgDeptUser t_ORGDEPTUSER : t_ORGDEPTUSERs){
            list.add(orgDeptUserRepository.convert2Domain(t_ORGDEPTUSER,null));
        }
        return new PageImpl<OrgDeptUser>(list, context.getPageable(), t_ORGDEPTUSERs.getTotalElements());
    }

    /**
     * 根据组织用户查询
     */
    @Override
    public List<OrgDeptUser> selectByOrgUser2(String orguserid){
        OrgDeptUserSearchContext context = new OrgDeptUserSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orguserid)){
            cn.ibizlab.r7.runtime.org.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.org.util.SearchFieldFilter();
            fieldFilter.setParam("orguserid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.org.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orguserid);
            context.getCondition().add(fieldFilter);
        }
        List<OrgDeptUser> list = new ArrayList<OrgDeptUser>();
        Page<cn.ibizlab.r7.runtime.org.core.repository.po.OrgDeptUser> t_ORGDEPTUSERs = orgDeptUserRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.org.core.repository.po.OrgDeptUser t_ORGDEPTUSER : t_ORGDEPTUSERs){
            list.add(orgDeptUserRepository.convert2Domain(t_ORGDEPTUSER,null));
        }
        return list;
    }
    /**
     * 根据组织查询
     */
    @Override
    public Page<OrgDeptUser> selectByOrg(String orgid){
        OrgDeptUserSearchContext context = new OrgDeptUserSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgid)){
            cn.ibizlab.r7.runtime.org.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.org.util.SearchFieldFilter();
            fieldFilter.setParam("orgid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.org.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgid);
            context.getCondition().add(fieldFilter);
        }
        List<OrgDeptUser> list = new ArrayList<OrgDeptUser>();
        Page<cn.ibizlab.r7.runtime.org.core.repository.po.OrgDeptUser> t_ORGDEPTUSERs = orgDeptUserRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.org.core.repository.po.OrgDeptUser t_ORGDEPTUSER : t_ORGDEPTUSERs){
            list.add(orgDeptUserRepository.convert2Domain(t_ORGDEPTUSER,null));
        }
        return new PageImpl<OrgDeptUser>(list, context.getPageable(), t_ORGDEPTUSERs.getTotalElements());
    }

    /**
     * 根据组织查询
     */
    @Override
    public List<OrgDeptUser> selectByOrg2(String orgid){
        OrgDeptUserSearchContext context = new OrgDeptUserSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgid)){
            cn.ibizlab.r7.runtime.org.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.org.util.SearchFieldFilter();
            fieldFilter.setParam("orgid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.org.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgid);
            context.getCondition().add(fieldFilter);
        }
        List<OrgDeptUser> list = new ArrayList<OrgDeptUser>();
        Page<cn.ibizlab.r7.runtime.org.core.repository.po.OrgDeptUser> t_ORGDEPTUSERs = orgDeptUserRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.org.core.repository.po.OrgDeptUser t_ORGDEPTUSER : t_ORGDEPTUSERs){
            list.add(orgDeptUserRepository.convert2Domain(t_ORGDEPTUSER,null));
        }
        return list;
    }




}
