package cn.ibizlab.r7.runtime.org.core.r7rt_org.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.org.core.r7rt_org.domain.Org;
import cn.ibizlab.r7.runtime.org.core.r7rt_org.filter.OrgSearchContext;
import cn.ibizlab.r7.runtime.org.core.r7rt_org.service.IOrgService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.org.util.SearchResult;

/**
 * 实体[组织] 服务对象接口实现
 */
@Service
public class OrgServiceImpl implements IOrgService {

    @Autowired
    cn.ibizlab.r7.runtime.org.core.repository.OrgRepository orgRepository;

    @Override
    @Transactional
    public boolean update(Org org) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.org.core.repository.po.Org t_ORG = orgRepository.convert2PO(org,null);
        bOk = orgRepository.update(t_ORG);
        orgRepository.convert2Domain(t_ORG,org) ;
        return bOk ;
    }

    @Override
    @Transactional
    public Org getOrgPrent(Org org) {
         return org;
    }

    @Override
    @Transactional
    public boolean remove(String orgid) {
        boolean bOk = false ;

        Org _org = this.get(orgid);
        bOk = orgRepository.remove(orgid);

        return bOk ;
    }

    @Override
    @Transactional
    public Org getOrgChild(Org org) {
         return org;
    }

    @Override
    public Org getDraft(Org org) {
        return org;
    }

    @Override
    @Transactional
    public boolean save(Org org) {
        if(org.getOrgId()==null){
    		return create(org);
    	}else{
            if(this.get(org.getOrgId())!=null){
    			return update(org);
    		}
    		return create(org);
    	}
    }

    @Override
    @Transactional
    public boolean create(Org org) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.org.core.repository.po.Org t_ORG = orgRepository.convert2PO(org,null);
        bOk = orgRepository.create(t_ORG);
        orgRepository.convert2Domain(t_ORG,org);


        return bOk ;
    }

    @Override
    public boolean checkKey(Org org) {
        return true;
    }

    @Override
    @Transactional
    public Org syncToUserGroup(Org org) {
         return org;
    }

    @Override
    @Transactional
    public Org get(String orgid) {
        cn.ibizlab.r7.runtime.org.core.repository.po.Org _t_ORG = orgRepository.get(orgid);
        if(_t_ORG == null)
            return null ;

        Org _org = orgRepository.convert2Domain(_t_ORG,null) ;

        return _org;
    }

    @Override
    @Transactional
    public Org get(Org org) {
        cn.ibizlab.r7.runtime.org.core.repository.po.Org t_ORG = orgRepository.get(org.getOrgId());
        orgRepository.convert2Domain(t_ORG,org);
        return org;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<Org> searchDefault(OrgSearchContext context) {
        List<Org> list = new ArrayList<Org>();
        Page<cn.ibizlab.r7.runtime.org.core.repository.po.Org> t_ORGs = orgRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.org.core.repository.po.Org t_ORG : t_ORGs){
            list.add(orgRepository.convert2Domain(t_ORG,null));
        }
        return new PageImpl<Org>(list, context.getPageable(), t_ORGs.getTotalElements());
    }


    /**
     * 根据组织查询
     */
    @Override
    public Page<Org> selectByPOrg(String orgid){
        OrgSearchContext context = new OrgSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgid)){
            cn.ibizlab.r7.runtime.org.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.org.util.SearchFieldFilter();
            fieldFilter.setParam("orgid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.org.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgid);
            context.getCondition().add(fieldFilter);
        }
        List<Org> list = new ArrayList<Org>();
        Page<cn.ibizlab.r7.runtime.org.core.repository.po.Org> t_ORGs = orgRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.org.core.repository.po.Org t_ORG : t_ORGs){
            list.add(orgRepository.convert2Domain(t_ORG,null));
        }
        return new PageImpl<Org>(list, context.getPageable(), t_ORGs.getTotalElements());
    }

    /**
     * 根据组织查询
     */
    @Override
    public List<Org> selectByPOrg2(String orgid){
        OrgSearchContext context = new OrgSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgid)){
            cn.ibizlab.r7.runtime.org.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.org.util.SearchFieldFilter();
            fieldFilter.setParam("orgid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.org.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgid);
            context.getCondition().add(fieldFilter);
        }
        List<Org> list = new ArrayList<Org>();
        Page<cn.ibizlab.r7.runtime.org.core.repository.po.Org> t_ORGs = orgRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.org.core.repository.po.Org t_ORG : t_ORGs){
            list.add(orgRepository.convert2Domain(t_ORG,null));
        }
        return list;
    }




}
